
#define URL_LENGTH	1024

#include <stdio.h>
#include <ddraw.h>
#include <windows.h>
#include <wininet.h>
#include "prototypes.h"
#include "resource.h"

#define NOT_CONNECTED	0
#define DOWNLOAD_VMI	1
#define DONE_VMI		2
#define DOWNLOAD_VMS	3
#define DONE_VMS		4

#define VMI_FILE_SIZE		108				// File size in bytes


// downloader.cpp necessary #defines and prototypes for each program using it.
void Status(HWND hWnd, char * szString);

#define DL_AGENT			"DirectVMS Downloader Agent"
#define WM_DONEDL			(WM_USER + 100)	// message value
#define WM_DL_VMI			1				// File id's to download
#define WM_DL_VMS			2

DWORD	g_dwFileSize,
		g_dwStatus = NOT_CONNECTED;
BYTE	g_bData[VMI_FILE_SIZE],
		g_bVMSGame[0x10000];
char	g_szURL[URL_LENGTH],
		g_szFileName[URL_LENGTH];

void DownloadFile(char *szSrcURL, void * vpBuffer, unsigned int iSize, HWND hWnd, DWORD dwType);

void EnableDlgButton(HWND hDlg, int nIDDlgItem, BOOL bEnable){
	if(hDlg) EnableWindow(GetDlgItem(hDlg, nIDDlgItem), bEnable);
}

void Status(HWND hWnd, char * szString){
	if(hWnd) SetDlgItemText(hWnd, IDC_EDIT_STATUS, szString);
}

BOOL CALLBACK DownloadProc(HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam){

	switch(msg) {
	case WM_INITDIALOG:
		g_dwFileSize = 0;
		g_dwStatus = NOT_CONNECTED;
		ZeroMemory(g_bData, sizeof(g_bData));
		ZeroMemory(g_szURL, sizeof(g_szURL));
		ZeroMemory(g_szFileName, sizeof(g_szFileName));
		EnableDlgButton(hwnd, IDC_BUTTON_SAVE, FALSE);
		SetDlgItemText(hwnd, IDC_EDIT_URL, "http://rpging.simplenet.com/directvms/RAIN.VMI");
		break;
	case WM_DONEDL:
		EnableDlgButton(hwnd, IDC_BUTTON_DOWNLOAD, TRUE);
		EnableDlgButton(hwnd, IDC_BUTTON_SAVE, TRUE);
		switch(wparam){
		case WM_DL_VMS:{
			FILE * fp;

			Status(hwnd, "Finished downloading VMS, saving file...");
			g_dwStatus = DONE_VMS;

			fp = fopen(g_szFileName, "wb");
			if(!fp)
				MessageBox(NULL, "Couldn't open a file for writing!", "Error Saving File!", MB_OK);

			fwrite(g_bVMSGame, g_dwFileSize, 1, fp);
			fclose(fp);

			Status(hwnd, "Saved file.");
			} break;
		case WM_DL_VMI: {
			char		szText[800];
			char *months[12] = {"January","February","March","April","May","June",
								"July","August","September","October","November","December"};

			g_dwStatus = DONE_VMI;

			Status(hwnd, "Finished downloading VMI.");

			// Update edit boxes
			ZeroMemory(szText, sizeof(szText));
			memcpy(szText, &g_bData[4], 32);
			SetDlgItemText(hwnd, IDC_EDIT_DESCRIPTION, szText);

			ZeroMemory(szText, sizeof(szText));
			memcpy(szText, &g_bData[36], 32);
			SetDlgItemText(hwnd, IDC_EDIT_COPYRIGHT, szText);


			ZeroMemory(szText, sizeof(szText));
			sprintf(szText, "%d:%d:%d %s %d, %d",
					g_bData[0x48],							// Hour
					g_bData[0x49],							// Minute
					g_bData[0x4a],							// Second
					months[g_bData[0x46] - 1],				// Month
					g_bData[0x47],							// Day
					g_bData[0x44] + (g_bData[0x45] << 8));	// Year
			SetDlgItemText(hwnd, IDC_EDIT_CREATED, szText);

			ZeroMemory(szText, sizeof(szText));
			memcpy(szText, &g_bData[80], 8);
			SetDlgItemText(hwnd, IDC_EDIT_RESOURCE, szText);

			ZeroMemory(szText, sizeof(szText));
			memcpy(szText, &g_bData[88], 12);
			SetDlgItemText(hwnd, IDC_EDIT_FILE, szText);

			g_dwFileSize = g_bData[105];
			g_dwFileSize <<= 8;
			g_dwFileSize += g_bData[104];
			ZeroMemory(szText, sizeof(szText));
			sprintf(szText, "%d", g_dwFileSize);
			SetDlgItemText(hwnd, IDC_EDIT_FILESIZE, szText);

			if(	((g_bData[88] & 0x53) == g_bData[0])&&
				((g_bData[89] & 0x45) == g_bData[1])&&
				((g_bData[90] & 0x47) == g_bData[2])&&
				((g_bData[91] & 0x41) == g_bData[3]))
					CheckDlgButton(hwnd, IDC_CHECK_SEGA, MF_CHECKED);
			else	CheckDlgButton(hwnd, IDC_CHECK_SEGA, MF_UNCHECKED);

			if(	((g_bData[91] & 0x53) == g_bData[0])&&
				((g_bData[90] & 0x45) == g_bData[1])&&
				((g_bData[89] & 0x47) == g_bData[2])&&
				((g_bData[88] & 0x41) == g_bData[3]))
					CheckDlgButton(hwnd, IDC_CHECK_AGES, MF_CHECKED);
			else	CheckDlgButton(hwnd, IDC_CHECK_AGES, MF_UNCHECKED);

			EnableDlgButton(hwnd, IDC_BUTTON_SAVE, TRUE);
			} break;
		}	//end switch dl type
		break;
	case WM_COMMAND:
		switch(LOWORD(wparam))
		{
		case IDC_BUTTON_RUN:
			if(g_dwStatus != DONE_VMS){
				MessageBox(NULL, "You need to save a VMS file before it can be run!", "Error Running!", MB_OK);
				break;
			}
			EndDialog(hwnd, FALSE);
			do_vmsgame(g_szFileName, NULL);
			break;
		case IDC_BUTTON_DOWNLOAD: {
			GetDlgItemText(hwnd, IDC_EDIT_URL, g_szURL, URL_LENGTH);
			EnableDlgButton(hwnd, IDC_BUTTON_DOWNLOAD, FALSE);
			EnableDlgButton(hwnd, IDC_BUTTON_SAVE, FALSE);
			g_dwStatus = DOWNLOAD_VMI;
			Status(hwnd, "Starting VMI download...");
			DownloadFile(g_szURL, (void *)&g_bData[0], VMI_FILE_SIZE, hwnd, WM_DL_VMI);
		   } break;

		case IDC_BUTTON_SAVE: {
			char		szText[URL_LENGTH];
			int			i,
						j;
			// Get a file name to write to
			OPENFILENAME ofn = {sizeof(OPENFILENAME),
								NULL,
								(HINSTANCE)GetWindowLong(hwnd, GWL_HINSTANCE),
								"VMS Game files (*.vms)\0*.vms\0All Files (*.*)\0*.*\0",
								NULL, 0, 0,
								g_szFileName, URL_LENGTH,
								NULL, 0,
								NULL,
								"Save VMS Game",
								/*OFN_ENABLESIZING |*/ OFN_HIDEREADONLY,
								0, 0, NULL,
								0, NULL, NULL
								};

			if(	(g_dwStatus != DONE_VMI)&&
				(g_dwStatus != DONE_VMS)){
				MessageBox(NULL, "You cannot save file while download in progress or you need to download the VMI file first!", "Error Saving!", MB_OK);
				break;
			}

			ZeroMemory(szText, sizeof(szText));
			ZeroMemory(g_bVMSGame, g_dwFileSize);

			g_szFileName[0] = 0;
			if(!GetSaveFileName(&ofn))	// If didn't specify a file, stop right here
				break;

			// Find the correct URL
			sprintf(szText, g_szURL);		// Copy the VMI File URL to the text
			for(i = strlen(szText); szText[i] != '/'; i--);
			i++;

			// Copy File name to end of URL name
			for(j = 88; g_bData[j] != NULL; j++, i++)
				szText[i] = g_bData[j];

			EnableDlgButton(hwnd, IDC_BUTTON_DOWNLOAD, FALSE);
			EnableDlgButton(hwnd, IDC_BUTTON_SAVE, FALSE);

			// Download the VMS compiled URL
			g_dwStatus = DOWNLOAD_VMS;
			Status(hwnd, "Starting VMS download...");
			DownloadFile(szText, &g_bVMSGame[0], g_dwFileSize, hwnd, WM_DL_VMS);
			} break;

		case IDCANCEL:
			EndDialog(hwnd, FALSE);
			break;
		}
	break;
	}
	return FALSE;
}


typedef struct DL_INFO {
	char	m_szSrcURL[1024];
	void *	m_pvData;
	DWORD	m_dwFileSize,
			m_dwType;
	HWND 	m_hWnd;
};


DWORD WINAPI Worker(void * pvParam){
	HINTERNET	hNet		= NULL,
				hFile		= NULL;
	struct DL_INFO *	pDL			= NULL;
	DWORD		dwBytesRead	= 0;

	pDL = pvParam;

	// Download the VMI File to the Global Data
	Status(pDL->m_hWnd, "Opening Internet connection...");
	hNet = InternetOpen(DL_AGENT,
						PRE_CONFIG_INTERNET_ACCESS,
						NULL, INTERNET_INVALID_PORT_NUMBER, 0);
	if(!hNet){
		MessageBox(NULL, "Couldn't open Internet connection!", "Internet Error!", MB_OK);
		goto EXIT;
	}

	Status(pDL->m_hWnd, "Opening online file...");
	hFile = InternetOpenUrl(hNet,
							pDL->m_szSrcURL,
							NULL, 0,
							INTERNET_FLAG_RAW_DATA,
							0);
	if(!hFile){
		InternetCloseHandle(hNet);
		MessageBox(NULL, pDL->m_szSrcURL, "Internet Error! Couldn't download URL:", MB_OK);
		goto EXIT;
	}

	Status(pDL->m_hWnd, "Downloading file...");
	if( !InternetReadFile(	hFile,
							pDL->m_pvData,
							pDL->m_dwFileSize,
							&dwBytesRead))
		MessageBox(NULL, "Didn't download file! The file may not work and may be corrupt!", "Internet Error!", MB_OK);

	InternetCloseHandle(hFile);
	InternetCloseHandle(hNet);

	Status(pDL->m_hWnd, "Finished downloading!");
	if(pDL->m_hWnd)
		PostMessage(pDL->m_hWnd, WM_DONEDL, (WPARAM)pDL->m_dwType, (LPARAM)NULL);

EXIT:
	free(pDL);
	return 0;
}

void DownloadFile(char * szSrcURL, void * vpBuffer, unsigned int iSize, HWND hWnd, DWORD dwType){
	DWORD		dwThreadID	= NULL;
	HANDLE		hThread		= NULL;
	struct DL_INFO	*	pDL	= NULL;
	struct DL_INFO	s;

	pDL = malloc(sizeof(s));
	sprintf(pDL->m_szSrcURL, szSrcURL);
	pDL->m_pvData = vpBuffer;
	pDL->m_dwFileSize = iSize;
	pDL->m_hWnd = hWnd;
	pDL->m_dwType = dwType;

	hThread = CreateThread(	NULL,			//no special attributes
							0,				//default stack size
							Worker,			//function body
							pDL,			//parameter
							NULL,			//creation flags use default
							&dwThreadID);	//thread id

	if(!hThread)
		MessageBox(NULL, "Couldn't create separate thread!", "Error Downloading!", MB_OK);

	CloseHandle(hThread);
}
